opal/class/opal_object.c File Reference.TH "opal/class/opal_object.c" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/class/opal_object.c \- Implementation of \fBopal_object_t\fP, the base opal foundation class. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include <stdio.h>\fP
.br
\fC#include 'opal/include/sys/atomic.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br
\fC#include 'ompi/include/constants.h'\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "static void \fBsave_class\fP (\fBopal_class_t\fP *cls)"
.br
.ti -1c
.RI "static void \fBexpand_array\fP (void)"
.br
.ti -1c
.RI "void \fBopal_class_initialize\fP (\fBopal_class_t\fP *cls)"
.br
.RI "\fILazy initialization of class descriptor. \fP"
.ti -1c
.RI "int \fBopal_class_finalize\fP (void)"
.br
.RI "\fIShut down the class system and release all memory. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "\fBopal_class_t\fP \fBopal_object_t_class\fP"
.br
.ti -1c
.RI "static \fBopal_atomic_lock_t\fP \fBclass_lock\fP = { { OPAL_ATOMIC_UNLOCKED } }"
.br
.ti -1c
.RI "static void ** \fBclasses\fP = NULL"
.br
.ti -1c
.RI "static int \fBnum_classes\fP = 0"
.br
.ti -1c
.RI "static int \fBmax_classes\fP = 0"
.br
.ti -1c
.RI "static const int \fBincrement\fP = 10"
.br
.in -1c
.SH "Detailed Description"
.PP 
Implementation of \fBopal_object_t\fP, the base opal foundation class. 


.SH "Function Documentation"
.PP 
.SS "int opal_class_finalize (void)"
.PP
Shut down the class system and release all memory. 
.PP
This function should be invoked as the ABSOLUTE LAST function to use the class subsystem. It frees all associated memory with ALL classes, rendering all of them inoperable. It is here so that tools like valgrind and purify don't report still-reachable memory upon process termination. 
.SS "void opal_class_initialize (\fBopal_class_t\fP *)"
.PP
Lazy initialization of class descriptor. 
.PP
Specifically cache arrays of function pointers for the constructor and destructor hierarchies for this class.
.PP
\fBParameters:\fP
.RS 4
\fIclass\fP Pointer to class descriptor 
.RE
.PP

.SH "Variable Documentation"
.PP 
.SS "\fBopal_class_t\fP opal_object_t_class"
.PP
\fBInitial value:\fP
.PP
.nf
 {
    'opal_object_t', 
    NULL,           
    NULL,           
    NULL,           
    1,              
    0,              
    NULL,           
    NULL            
}
.fi
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
